/* =================================================================================
 *  alberi.h
 * =================================================================================
 * Contiene la definizione di albero binario (di interi), ed i prototipi di
 * varie funzioni e procedure su alberi binari (di ricerca).
 *
 *  Authors:     Emanuela Fachini  (fachini@di.uniroma1.it )
 *               Irene Finocchi    (finocchi@di.uniroma1.it)
 *  Last change: 10 Maggio 2005
 *  Changed by:  Irene Finocchi
*/

#ifndef ALBERI_H
#define ALBERI_H

#include <stdio.h>
#include<stdlib.h>

struct nodoalbero{
	struct nodoalbero *rPtr;
	int elem;
	struct nodoalbero *lPtr;
};

typedef struct nodoalbero TREENODE;
typedef TREENODE *TreePtr;


/* Costruzione di un albero binario inserito da input. */
TreePtr creaalbero();

/* Stampa in inorder i valori contenuti nell'albero */
void stampaAlberoInorder(TreePtr);

/* Stampa l'albero indentato */
void stampaIndentata(TreePtr, int);

/* Verifica se l'albero soddisfa la proprieta' di ricerca */
int AlberoDiRicerca(TreePtr T);

TreePtr TrovaIesimo( TreePtr t, int *i);

void  compresi(TreePtr t,int i,int j);

#endif
