/* =================================================================================
 *  mainAlberi.c
 * =================================================================================
 *  Programma di test per esercizi su alberi binari di ricerca
 *  Authors:     Emanuela Fachini  (fachini@di.uniroma1.it )
 *               Irene Finocchi    (finocchi@di.uniroma1.it)
 *  Last change: 10 Maggio 2005
 *  Changed by:  Irene Finocchi
*/

#include "alberi.h"

int main(void) {

	TreePtr T;
	int i,j;

    printf("Costruzione di un albero binario (di ricerca) inserito da input.\n\n") ;
    printf("I nodi vanno inseriti in preordine come sequenza di coppie <i,j> in cui:\n") ;
    printf("   i rappresenta il valore intero del nodo\n") ;
    printf("   j vale: 0 se il nodo non ha figli, -1 se ha solo figlio sinistro\n") ;
    printf("           1 se ha solo figlio destro, 2 se ha entrambi i figli\n\n") ;

    printf("Inserisci ora la sequenza di coppie i j, terminando con un ritorno a capo\n") ;
    printf("(ad esempio 20 2 18 -1 13 0 30 2 30 0 45 2 30 0 71 0):\n") ;

	T=creaalbero();

	printf("\nVisita inorder dell'albero:\n");
	stampaAlberoInorder(T);

	printf("\n\n");

	printf("Stampa indentata dell'albero \n\n");
	stampaIndentata(T,0);

	printf("\n");

	printf("\nVerifico se l'albero e' di ricerca:\n");

	/* Verifica se l'albero e' un albero binario di ricerca */
	if (AlberoDiRicerca(T)==1) printf("L'albero soddisfa la proprieta' di ricerca.\n\n");
	else printf("L'albero non soddisfa la proprieta' di ricerca.\n\n");

	printf("TEST RICERCA I-ESIMO NODO\n");
	while (1) {
		printf("Inserisci i (-1 per terminare): ");
		scanf("%d",&i);
		if (i==-1) break;
		TreePtr node = TrovaIesimo(T,&i);
		if (!node) printf("L'i-esimo nodo non esiste.\n");
		else printf("L'i-esimo nodo ha valore %d.\n",node->elem);
	}
    
	printf("\nTEST STAMPA NODI COMPRESI TRA I E J\n");
	while (1) {
		printf("Inserisci i (-1 per terminare): ");
		scanf("%d",&i);
		if (i==-1) break;
		printf("Inserisci j: ");
		scanf("%d",&j);
		printf("Gli elementi compresi tra %d e %d sono: ",i,j);
		compresi(T,i,j);
	}

	printf("\nSayonara!\n");

	return 1;
}

